#!/usr/bin/python3
# Electronic dice.  By Mike Cook
import time, random
import RPi.GPIO as io

LEDnumber = [23,4,25,10,17,8,22]
dicePattern = [0,0x08,0x41,0x2A,0x63,0x6B,0x77]
pushButton = 7

def main():
   print("Electronic Dice Ctrl C to quit")
   initGPIO()
   number = 1
   while 1:      
      displayRoll()
      displayNumber(number)
      number = generateNumber()

def displayRoll(): # pattern to show when rolling
    for i in range(0,20):
        displayNumber(random.randint(1,6))
        time.sleep(0.1)
        
def displayNumber(number):
    pattern = dicePattern[number]
    for i in range(0,len(LEDnumber)):
        io.output(LEDnumber[i],pattern & 1)
        pattern = pattern >> 1

def generateNumber(): # wait for a push
    throw = random.randint(1,6)
    while io.input(pushButton) == 1:
        pass
    time.sleep(0.030) # debounce delay
    while io.input(pushButton) == 0:
        throw += 1
        if throw >6: # wrap round the number
            throw = 1         
    return throw           

def initGPIO():
   io.setmode(io.BCM)
   io.setwarnings(False)    
   for pin in range (0,len(LEDnumber)):
      io.setup(LEDnumber[pin],io.OUT) # make pin into an output
   io.setup(pushButton,io.IN,pull_up_down=io.PUD_UP) # make pin into an input   
      
# Main program logic:
if __name__ == '__main__':    
     main()
