#!/usr/bin/env python3
# Class for driving APA102 LEDs
# Save this in a file called apa102bang.py
#By Mike Cook

import RPi.GPIO as io
io.setwarnings(False)

class Apa102bang(): # Define our class

    def __init__(self,numberLeds,data,clock,bright):
        self.setBrightness(bright)
        self.da = data
        self.ck = clock
        self.numLeds = numberLeds
        io.setmode(io.BCM)
        io.setup(self.ck, io.OUT)
        io.setup(self.da, io.OUT)
        io.output(self.ck, io.HIGH)
        io.output(self.da, io.HIGH)
        self.ledArray = [self.br<<24 for i in range(0, self.numLeds)]

    def setBrightness(self, brightness):
        if brightness > 31:
           brightness = 31
        if brightness < 0:
           brightness = 0
        self.br = brightness | 0xE0

    def setLed(self,pos,col):
        if pos < self.numLeds and pos >= 0:
           self.ledArray[pos] = (self.br<<24)|(col[2]<<16)|(col[1] <<8)|col[0]

    def setAll(self,col):
       for i in range(0, self.numLeds):
           self.ledArray[i] = (self.br<<24)|(col[2]<<16)|(col[1] <<8)|col[0]

    def show(self):
        io.output(self.da,io.LOW)
        for i in range(0, 32): # send header
           io.output(self.ck, io.LOW)
           io.output(self.ck, io.HIGH)
        for i in range(0,self. numLeds):
           d = self.ledArray[i] # send data
           for j in range(0, 32):
             io.output(self.ck, io.LOW)
             if d & 0x80000000 :
                io.output(self.da, io.HIGH)
             else:
                io.output(self.da, io.LOW)
             d = d << 1
             io.output(self.ck, io.HIGH)
        io.output(self.da, io.LOW)
        for i in range(0, 33+(self.numLeds>>1)): # send footer
           io.output(self.ck, io.LOW)
           io.output(self.ck, io.HIGH)
