#!/usr/bin/env python3
# Adafruit 8X8 matrix broach

import time, random
from apa102bang import Apa102bang

dataPin = 23 ; clockPin = 24
lenX = 8 ; lenY = 8
length = lenX * lenY ; brightness = 1
half = int(length / 2)
patternDuration = 8.0
leds = Apa102bang(length, dataPin, clockPin, brightness)

def main():
   print("APA102 8 by 8 matrix broach - Cnt C to stop")
   nextChange = time.time() + patternDuration
   pattern = 1
   while True:
      if pattern == 1:
         pattern1()
      if pattern == 2:
         pattern2()
      if pattern == 3:
         pattern3()
      if time.time() > nextChange:
         nextChange = time.time() + patternDuration
         pattern +=1
         if pattern > 3:
            pattern = 1

def pattern1():
     for side in range(1,lenX):
       for i in range(0,lenX):
         square(i,i,side,randCol())
         leds.show()
         time.sleep(0.1)
       time.sleep(0.6)
       leds.setAll((0,0,0))
     leds.setAll((0,0,0))
     time.sleep(0.6)

def pattern2():
   start = 0
   for side in range(lenX-1,0,-2):
       square(start,start,side,randCol())
       leds.show()
       time.sleep(0.08)
       start += 1
      #time.sleep(0.6)
      #leds.setAll((0,0,0))

def pattern3():
   col = randCol()
   for t in range(1,8):
      line(0,0,t,0,col)
      hold()
   for t in range (1,8):
      line(0,0,8,t,col)
      hold()
   for t in range (8,0,-1):
      line(0,0,t,8,col)
      hold()
   for t in range(7,0,-1):
      line(0,0,0,t,col)
      hold()

def hold():
   leds.show()
   time.sleep(0.08)
   leds.setAll((0,0,0))

def matrix(x,y,col):
   pixel = x + y*8
   if pixel < length and x < lenX:
      leds.setLed(pixel,col)

def squareFill(x,y,side,col):
   for xp in range(x,x+side):
      for yp in range(y,y+side):
         matrix(xp,yp,col)

def square(x,y,side,col):
   for xp in range(x,x+side):
      matrix(xp,y,col)
   for xp in range(x,x+side+1):
      matrix(xp,y+side,col)
   for yp in range(y,y+side):
      matrix(x,yp,col)
   for yp in range(y,y+side):
      matrix(x+side,yp,col)

def line(xs,ys,xe,ye,col):
   xl = xe - xs
   yl = ye - ys
   if xl > yl:
      xinc = 1.0
      yinc = yl/xl
   else:
      yinc = 1.0
      xinc = xl/yl
   x= float(xs) ; y = float(ys)
   while x != xe or y != ye:
      matrix(int(x),int(y),col)
      x += xinc
      y += yinc

def randCol():
   r = 0; g =0; b=0
   while r+g+b == 0:
      r = random.randint(0,2) * 64
      g = random.randint(0,2) * 64
      b = random.randint(0,2) * 64
   return (r,g,b)

# Main program logic:
if __name__ == "__main__":
  try:
    main()
  except KeyboardInterrupt:
    pass
# turn off all LEDs
leds.setAll((0,0,0))
leds.show()
